from charms.reactive import when, set_flag, clear_flag
from charms.reactive import Endpoint


class CondaProvides(Endpoint):

    def configure(self, url, sha, conda_extra_packages=None,
                  conda_extra_pip_packages=None):
        """
        Provide the url, sha and optionally conda_extra_packages
        and conda_exrta_pip_packages to the requirer:
            - url
            - sha
            - conda_extra_packages
            - conda_extra_pip_packages
        """

        for relation in self.relations:
            ctxt = {
                'url': url,
                'sha': sha,
            }
            if conda_extra_packages:
                ctxt['conda_extra_packages'] = conda_extra_packages
            if conda_extra_pip_packages:
                ctxt['conda_extra_pip_packages'] = conda_extra_pip_packages

            relation.to_publish.update(ctxt)
